Summary: Honeypot daemon
Name: honeyd
Version: 1.5c
Release: 21%{?dist}
License: GPLv2+ and BSD
Group: Applications/Internet
URL: http://www.honeyd.org/
Source0: http://www.citi.umich.edu/u/provos/honeyd/honeyd-%{version}.tar.gz
Source1: http://www.citi.umich.edu/u/provos/honeyd/arpd-0.2.tar.gz
Source2: honeyd.service
Source3: honeyd.conf
Source4: honeyd.sysconfig
Source5: farpd.sysconfig
Source6: README.fedora
Source7: farpd.service
Patch1: honeyd-1.5c-gcc.patch
Patch2: honeyd-1.5c-pidFile.patch
Patch3: honeyd-1.5c-flags.patch
Patch4: honeyd-1.5c-withlib.patch
Patch5: honeyd-1.5c-lt.patch
Patch6: honeyd-1.5c-extint.patch
Patch7: honeyd-1.5c-libevent2.patch
Patch8: honeyd-1.5c-automake13.patch
Requires: perl-SNMP_Session
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
BuildRequires: readline-devel, zlib-devel
BuildRequires: python-devel, pcre-devel
BuildRequires: libpcap-devel, libdnet-devel, libevent-devel
BuildRequires: autoconf, automake, libtool
BuildRequires: systemd-units
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
Honeyd is a small daemon that creates virtual hosts on a network.
The hosts can be configured to run arbitrary services, and their
TCP personality can be adapted so that they appear to be running
certain versions of operating systems. Honeyd enables a single
host to claim multiple addresses on a LAN for network simulation.

%prep
%setup -q -a 1
cp -p %{SOURCE6}  ./
%patch1 -p1 -b .gcc
%patch2 -p1 -b .pidFile
%patch3 -p1 -b .flags
%patch4 -p1 -b .withlib
%patch5 -p1 -b .lt
%patch6 -p1 -b .extint
%patch7 -p1 -b .libevent2
%patch8 -p1 -b .automake13

sed -i 's,arpd,farpd,' arpd/arpd.8

%build
autoreconf -i
(cd arpd && autoreconf -i)
%configure
make %{?_smp_mflags}
cd arpd
%configure
make %{?_smp_mflags}


%install
rm -rf %{buildroot}
install -d %{buildroot}%{_datadir}/honeyd
make install DESTDIR=%{buildroot}
cp -aRf scripts %{buildroot}/%{_datadir}/%{name}/
install -d -m 755 %{buildroot}%{_sysconfdir}/sysconfig
install -p -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/honeyd.conf
install -p -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/honeyd
install -p -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/sysconfig/farpd

#create fake arpd
cd arpd
make install DESTDIR=%{buildroot}
mv %{buildroot}/%{_sbindir}/arpd %{buildroot}/%{_sbindir}/farpd
mv %{buildroot}/%{_mandir}/man8/arpd.8 %{buildroot}/%{_mandir}/man8/farpd.8

#remove devel part 
rm -rf %{buildroot}/%{_includedir}
rm -rf %{buildroot}/%{_libdir}

#clean stuff
chmod 755 %{buildroot}/%{_datadir}/honeyd/scripts/snmp/fake-snmp.pl
chmod 755 %{buildroot}/%{_datadir}/honeyd/scripts/snmp/buildSNMPConfig.pl
rm -rf %{buildroot}/%{_datadir}/honeyd/scripts/test.sh

install -D -p -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/honeyd.service
install -D -p -m 644 %{SOURCE7} %{buildroot}%{_unitdir}/farpd.service


%clean
rm -rf %{buildroot}

%post
if [ $1 -eq 1 ] ; then 
    # Initial installation 
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%preun
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable honeyd.service > /dev/null 2>&1 || :
    /bin/systemctl stop honeyd.service > /dev/null 2>&1 || :
    /bin/systemctl --no-reload disable farpd.service > /dev/null 2>&1 || :
    /bin/systemctl stop farpd.service > /dev/null 2>&1 || :
fi

%postun
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
    # Package upgrade, not uninstall
    /bin/systemctl try-restart honeyd.service >/dev/null 2>&1 || :
    /bin/systemctl try-restart farpd.service >/dev/null 2>&1 || :
fi

%triggerun -- honeyd < 1.5c-17
# Save the current service runlevel info
# User must manually run systemd-sysv-convert --apply honeyd
# and systemd-sysv-convert --apply farpd
# to migrate them to systemd targets
/usr/bin/systemd-sysv-convert --save honeyd >/dev/null 2>&1 ||:
/usr/bin/systemd-sysv-convert --save farpd >/dev/null 2>&1 ||:

# Run these because the SysV package being removed won't do them
/sbin/chkconfig --del honeyd >/dev/null 2>&1 || :
/sbin/chkconfig --del farpd >/dev/null 2>&1 || :
/bin/systemctl try-restart honeyd.service >/dev/null 2>&1 || :
/bin/systemctl try-restart farpd.service >/dev/null 2>&1 || :

%files
%defattr(-, root, root, 0755)
%doc LICENSE README config.sample nmap.prints README.fedora
%config(noreplace) %{_sysconfdir}/honeyd.conf
%config(noreplace) %{_sysconfdir}/sysconfig/honeyd
%config(noreplace) %{_sysconfdir}/sysconfig/farpd
%{_unitdir}/honeyd.service
%{_unitdir}/farpd.service
%{_bindir}/hsniff
%{_bindir}/honeydstats
%{_bindir}/honeyd
%{_bindir}/honeydctl
%{_sbindir}/farpd
%{_datadir}/honeyd/
%{_mandir}/man1/honeydctl.1*
%{_mandir}/man8/honeyd.8*
%{_mandir}/man8/farpd.8*

%changelog
* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5c-21
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jul 17 2013 Petr Pisar <ppisar@redhat.com> - 1.5c-20
- Perl 5.18 rebuild
- Build-require systemd-units

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5c-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5c-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed Apr 18 2012 Jon Ciesla <limburgher@gmail.com> - 1.5c-17
- Migrate to systemd, BZ 770309.

* Fri Feb 17 2012 Karsten Hopp <karsten@redhat.com> - 1.5c-16
- automake-1.11.3 fix 

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5c-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Jul 26 2011 Peter Vrabec <pvrabec@redhat.com> 1.5c-14
- merge gentoo and ubuntu patch to make it build with libevent 2.0

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5c-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Sep 29 2010 jkeating - 1.5c-12
- Rebuilt for gcc bug 634757

* Wed Sep 22 2010 Peter Vrabec <pvrabec@redhat.com> 1.5c-11
- rebuild

* Wed Aug 11 2010 David Malcolm <dmalcolm@redhat.com> - 1.5c-10
- recompiling .py files against Python 2.7 (rhbz#623317)

* Thu Mar 18 2010 Peter Vrabec <pvrabec@redhat.com> 1.5c-9
- Remove code using event_gotsig and event_sigcb, this external integers
  are deprecated and no longer defined in newer versions of libevent (#555489)
- ^ fix from Debian


* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5c-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5c-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Dec 01 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 1.5c-6
- Rebuild for Python 2.6

* Wed Aug  6 2008 Stepan Kasal <skasal@redhat.com> 1.5c-5
- add lt.patch: removes a hack which circumvented libtool and prevents
  collission of fdpass.lo with fdpass.o

* Wed Aug  6 2008 Stepan Kasal <skasal@redhat.com> 1.5c-4
- autoconfigury fixes

* Sat Aug 02 2008 Peter Vrabec <pvrabec@redhat.com> 1.5c-3
- adjust package to fedora standards

* Fri Jul 25 2008 Peter Vrabec <pvrabec@redhat.com> 1.5c-2
- fix sysconfig file 
- fix requires
- change pid and man file of farpd

* Mon Jul 21 2008 Peter Vrabec <pvrabec@redhat.com> 1.5c-1
- initial package build


